#pragma once
#include <string>
#include "State.h"
#include "System.h"

#include "LoadingState.h"
#include "RunningState.h"
#include "UnloadingState.h"

namespace ChaosEngine
{
	// the initializing state creates and registers all the states needed by the game state machine
	// after all the other states are registered, it passes control to the next state
	class InitializingState : public State
	{
	public:
		InitializingState( System* pSystem );
		virtual ~InitializingState( void );
		virtual void Update( float fDeltaTime );
	};
};
