/*************************************************************************
 *                                                                       *
 * Open Dynamics Engine, Copyright (C) 2001,2002 Russell L. Smith.       *
 * All rights reserved.  Email: russ@q12.org   Web: www.q12.org          *
 *                                                                       *
 * This library is free software; you can redistribute it and/or         *
 * modify it under the terms of EITHER:                                  *
 *   (1) The GNU Lesser General Public License as published by the Free  *
 *       Software Foundation; either version 2.1 of the License, or (at  *
 *       your option) any later version. The text of the GNU Lesser      *
 *       General Public License is included with this library in the     *
 *       file LICENSE.TXT.                                               *
 *   (2) The BSD-style license that is included with this library in     *
 *       the file LICENSE-BSD.TXT.                                       *
 *                                                                       *
 * This library is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
 * LICENSE.TXT and LICENSE-BSD.TXT for more details.                     *
 *                                                                       *
 *************************************************************************/

/* per-machine configuration. this file is automatically generated. */

#ifndef _ODE_CONFIG_H_
#define _ODE_CONFIG_H_

/* shared lib definitions */
#ifndef SHAREDLIBIMPORT
#define SHAREDLIBIMPORT
#endif
#ifndef SHAREDLIBEXPORT
#define SHAREDLIBEXPORT
#endif

/* standard system headers */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include <malloc.h>

#ifdef __cplusplus
extern "C" {
#endif

/* is this a pentium on a gcc-based platform? */
/* #define PENTIUM 1 -- not a pentium */

/* integer types (we assume int >= 32 bits) */
typedef char int8;
typedef unsigned char uint8;
typedef short int16;
typedef unsigned short uint16;
typedef int int32;
typedef unsigned int uint32;

/* an integer type that we can safely cast a pointer to and
 * from without loss of bits.
 */
typedef unsigned int intP;

/* select the base floating point type */
#define dSINGLE 1

/* the floating point infinity */
#ifndef INF_DEFINED
#define INF_DEFINED
union dInfBytes { unsigned char c[4]; float f; };
static union dInfBytes dInfinityValue = {{0,0,0x80,0x7f}};
#define dInfinity (dInfinityValue.f)
#endif

/* ODE feature configuration */


#ifdef __cplusplus
}
#endif
#endif